package com.pj.project.tb_business_people;

import cn.dev33.satoken.annotation.SaCheckPermission;
import com.pj.current.satoken.StpUserUtil;
import com.pj.project4sp.SP;
import com.pj.utils.sg.AjaxError;
import com.pj.utils.sg.AjaxJson;
import com.pj.utils.so.SoMap;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;


/**
 * Controller: tb_business_people -- 核酸检测人员
 * @author qzy 
 */
@RestController
@RequestMapping("/TbBusinessPeople/")
public class TbBusinessPeopleController {

	/** 底层 Service 对象 */
	@Autowired
	TbBusinessPeopleService tbBusinessPeopleService;

	/** 增 */
	@RequestMapping("deleteById")
	@Transactional(rollbackFor = Exception.class)
	public AjaxJson deleteById(){
		SoMap so = SoMap.getRequestSoMap();
		String id=so.getString("id");
		tbBusinessPeopleService.removeById(id);
		return AjaxJson.getSuccess();
	}



	/** 删 - 根据id列表 */
	@RequestMapping("deleteByIds")
	@SaCheckPermission(TbBusinessPeople.PERMISSION_CODE)
	public AjaxJson deleteByIds(){
		List<Long> ids = SoMap.getRequestSoMap().getListByComma("ids", long.class);
		int line = SP.publicMapper.deleteByIds(TbBusinessPeople.TABLE_NAME, ids);
		return AjaxJson.getByLine(line);
	}

	/** 改 */
	@RequestMapping("update")
	@SaCheckPermission(TbBusinessPeople.PERMISSION_CODE)
	public AjaxJson update(TbBusinessPeople t){
		int line = tbBusinessPeopleService.update(t);
		return AjaxJson.getByLine(line);
	}

	/** 查 - 根据id */
	@RequestMapping("getById")
	public AjaxJson getById(Long id){
		TbBusinessPeople t = tbBusinessPeopleService.getById(id);
		return AjaxJson.getSuccessData(t);
	}

	/** 查集合 - 根据条件（参数为空时代表忽略指定条件） */
	@RequestMapping("getList")
	public AjaxJson getList() {
		SoMap so = SoMap.getRequestSoMap();
		List<TbBusinessPeople> list = tbBusinessPeopleService.getList(so.startPage());
		return AjaxJson.getPageData(so.getDataCount(), list);
	}




	// ------------------------- 前端接口 -------------------------


	/** 改 - 不传不改 [G] */
	@RequestMapping("updateByNotNull")
	public AjaxJson updateByNotNull(Long id){
		AjaxError.throwBy(true, "如需正常调用此接口，请删除此行代码");
		// 鉴别身份，是否为数据创建者
		long userId = SP.publicMapper.getColumnByIdToLong(TbBusinessPeople.TABLE_NAME, "user_id", id);
		AjaxError.throwBy(userId != StpUserUtil.getLoginIdAsLong(), "此数据您无权限修改");
		// 开始修改 (请只保留需要修改的字段)
		SoMap so = SoMap.getRequestSoMap();
		so.clearNotIn("id", "name", "phone", "businessId", "createTime").clearNull().humpToLineCase();
		int line = SP.publicMapper.updateBySoMapById(TbBusinessPeople.TABLE_NAME, so, id);
		return AjaxJson.getByLine(line);
	}
	
	
	
	
	
	

}
